#include <bits/stdc++.h>
using namespace std;
const int R = 1 << 19;

multiset <pair <int, int> > dr[2 * R + 5];
int tab[R], n, q;

void upd(int node, int value, pair <int, int> previous) {
	if (previous.first != -1) dr[node].erase(dr[node].find(previous));
	dr[node].insert(make_pair(value, previous.second));
}

void insert(int x, int value, pair <int, int> previous) {
	x += R-1;
	while (x > 0) {
		upd(x, value, previous);
		x >>= 1;
	}
}

void update(int position, int value) {
	insert(position, value, make_pair(tab[position], position));
	tab[position] = value;
}


void query_one_set(int node, int value, pair <int, int> &best_result) {
	multiset <pair <int, int> > :: iterator it = dr[node].upper_bound({value, INT_MAX});
	if (it == dr[node].end()) return;
	best_result = min(best_result, *it);
}

void query(int x, int y, int value, pair <int, int> &best_result) {
	x += R-1; y += R-1;
	query_one_set(x, value, best_result);
	if (x != y) query_one_set(y, value, best_result);
	while (x + 1 < y) {
		if (x % 2 == 0) query_one_set(x + 1, value, best_result);
		if (y % 2 == 1) query_one_set(y - 1, value, best_result);
		x /= 2;
		y /= 2;
	}
}

void smallest_successor(int x, int y, int value) {
	pair <int, int> best_result = {INT_MAX, 0};
	query(x, y, value, best_result);
	if (best_result.first == INT_MAX) cout << "NIE\n";
	else cout << best_result.second << "\n";
}

int getMax(int node) {
	multiset <pair <int, int> > :: iterator it = dr[node].end();
	--it;
	return it->first;
}

int search(int x, int value) {
	while (x < R) {
		if (getMax(2 * x) > value) x = 2 * x;
		else {
			assert(getMax(2 * x + 1) > value);
			x = 2 * x + 1;
		}
	}

	return x - R + 1;
}

void query_first(int gdzie, int pocz, int kon, int x, int y, int value, int &answer) {
	if (y < pocz || x > kon) return;
	if (answer != INT_MAX) return;
	if (x <= pocz && y >= kon) {
		if (getMax(gdzie) > value) answer = search(gdzie, value);
		return;
	}

	int sr = (pocz + kon) >> 1;
	query_first(2 * gdzie, pocz, sr, x, y, value, answer);
	query_first(2 * gdzie + 1, sr + 1, kon, x, y, value, answer);
}

void first_successor(int x, int y, int value) {
	int answer = INT_MAX;
	query_first(1, 1, R, x, y, value, answer);
	if (answer == INT_MAX) cout << "NIE\n";
	else cout << answer << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin >> n >> q;
	for (int i=1; i<=n; ++i) {
		cin >> tab[i];
		insert(i, tab[i], make_pair(-1, i));
	}

	for (int zap = 1; zap <= q; ++zap) {
		string s;
		cin >> s;
		if (s == "zmiana") {
			int pos, val;
			cin >> pos >> val;
			update(pos, val);
		}
		else if (s == "najtaniej") {
			int x, y, val;
			cin >> x >> y >> val;
			smallest_successor(x, y, val);
		}
		else {
			assert(s == "najszybciej");
			int x, y, val;
			cin >> x >> y >> val;
			first_successor(x, y, val);
		}
	}

    return 0;
}
